/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//
//	FileName	Main.c
//	Version		1.00
//	MCU		H8/3694
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2007/04/19	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	[^]vOłB
//	莞ԂƂɁA[^̑xƉ]ς܂B
//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2007

*/

#include "3694s.h"

/*[^p[q*/
#define FORWARD         IO.PDR7.BIT.B4  /*[^]M|[g*/
#define BACK            IO.PDR7.BIT.B5  /*[^t]M|[g*/
#define PWM             TW.GRB          /*DUTYݒ背WX^*/

#define MAX_DUTY 99
#define MIN_DUTY 1


extern char *_D_ROM, *_B_BGN, *_B_END, *_D_BGN, *_D_END;
                                        /*f[^ZNVԒn*/
void _INITSCT(void)
{
        char *p, *q ;
        /* f[^̈[ŏ */
        for (p=_B_BGN; p<_B_END ; p++)
                *p=0;
        /*f[^ROM ォRAM փRs[ */
        for (p=_D_BGN, q=_D_ROM; p<_D_END; p++, q++)
                *p=*q;
}

void init_timer(){



        /*^C}V(1ms)̐ݒ*/
        TV.TCRV0.BYTE = 0x0b;   /*RyA}b`AŃJE^NA*/
        TV.TCRV1.BIT.ICKS=1;    /*/128ŃJEg*/
        TV.TCORA = 156;

        /*^C}W(PWM)̐ݒ*/
        TW.TMRW.BIT.PWMB=1;     /*FTIOB[qPWM MODEɐݒ*/
        TW.TCRW.BYTE=0X82;      /*GRARyA}b`Ń^C}JE^NA*/
                                /*FTIOB[ql1*/
        /*TW.TCRW.BIT.CKS=3;    /**/
        TW.TIOR0.BIT.IOB=1;     /*GRBRyA}b`FTIOB[q0o*/
        TW.GRA=100;             /*PWMg20MHz/100 =200kHz*/
        TW.GRB=5;               /*PWMó@f[eB5%*/

        TW.TMRW.BIT.CTS=1;      /*^C}W^C}JE^JEgX^[g*/


}

void wait_m(long msec)
{
        if(msec<0) msec=-msec;
        while(msec){
                while(!TV.TCSRV.BIT.CMFA);
                TV.TCSRV.BIT.CMFA=0;
                msec--;
        }
}

void output_wheel(short duty)
{
        if(duty > 0){                                   /*duty*/
                FORWARD =1;                                     /*ԗ֑Oiw*/
                BACK    =0;
        }
        else if(duty < 0){                              /*duty*/
                FORWARD =0;                                     /*ԗ֌ގw*/
                BACK    =1;
                duty = -duty;                                   /*]Ő̒l*/
        }
        else{                                           /*duty0*/
                FORWARD = 1;                                    /*~w*/
                BACK    = 1;
                PWM     = MIN_DUTY;
        }
        if(duty > MAX_DUTY)     duty = MAX_DUTY;        /*f[eB̍őlݒ*/
        if(duty < MIN_DUTY)     duty = MIN_DUTY;        /*f[eB̍ŏlݒ*/
        PWM     = duty;                                 /*PWMo*/
}

void main(void)
{
        IO.PCR7 |= 0x30;                /*[^]t]|[go͐ݒ*/

        init_timer();                   /*^C}*/

        while(1){
                output_wheel(20);
                wait_m(5000);     /*5b҂*/
                output_wheel(50); /*duty=50%*/
                wait_m(5000);
                output_wheel(100);
                wait_m(5000);
        	
        	output_wheel(-20);
                wait_m(5000);     /*5b҂*/
                output_wheel(-50); /*duty=50%*/
                wait_m(5000);
                output_wheel(-100);
                wait_m(5000);
        }
}